3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
22 # do not redirect again
24 *' --tee '*|*' --va'*)
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
34 # Keep the original TERM for say_color
37 # For repeatability, reset the environment to known value.
43 export LANG LC_ALL PAGER TERM TZ
49 my $ok = join("|", qw(
58 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
59 print join("\n", @vars);
61 GIT_AUTHOR_EMAIL=author@example.com
62 GIT_AUTHOR_NAME='A U Thor'
63 GIT_COMMITTER_EMAIL=committer@example.com
64 GIT_COMMITTER_NAME='C O Mitter'
66 export GIT_MERGE_VERBOSITY
67 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
68 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
71 # Protect ourselves from common misconfiguration to export
72 # CDPATH into the environment
77 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
79 echo "* warning: Some tests will not work if GIT_TRACE" \
80 "is set as to trace on STDERR ! *"
81 echo "* warning: Please set GIT_TRACE to something" \
82 "other than 1, 2 or true ! *"
88 # A regexp to match 5 and 40 hexdigits
89 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
90 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
92 # Each test should start with something like this, after copyright notices:
94 # test_description='Description of this test...
95 # This test checks if command xyzzy does the right thing...
98 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
99 TERM=$ORIGINAL_TERM &&
102 tput bold >/dev/null 2>&1 &&
103 tput setaf 1 >/dev/null 2>&1 &&
104 tput sgr0 >/dev/null 2>&1
108 while test "$#" -ne 0
111 -d|--d|--de|--deb|--debu|--debug)
113 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
114 immediate=t; shift ;;
115 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
116 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
117 -h|--h|--he|--hel|--help)
119 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
121 -q|--q|--qu|--qui|--quie|--quiet)
122 # Ignore --quiet under a TAP::Harness. Saying how many tests
123 # passed without the ok/not ok details is always an error.
124 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
126 with_dashes=t; shift ;;
129 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
130 valgrind=t; verbose=t; shift ;;
132 shift ;; # was handled already
134 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
137 echo "error: unknown test option '$1'" >&2; exit 1 ;;
141 if test -n "$color"; then
147 error) tput bold; tput setaf 1;; # bold red
148 skip) tput bold; tput setaf 2;; # bold green
149 pass) tput setaf 2;; # green
150 info) tput setaf 3;; # brown
151 *) test -n "$quiet" && return;;
161 test -z "$1" && test -n "$quiet" && return
168 say_color error "error: $*"
177 test "${test_description}" != "" ||
178 error "Test script did not set test_description."
180 if test "$help" = "t"
182 echo "$test_description"
187 if test "$verbose" = "t"
191 exec 4>/dev/null 3>/dev/null
200 test_external_has_tap=0
204 if test -n "$GIT_EXIT_OK"
208 echo >&5 "FATAL: Unexpected exit with code $code"
216 # The semantics of the editor variables are that of invoking
217 # sh -c "$EDITOR \"$@\"" files ...
219 # If our trash directory contains shell metacharacters, they will be
220 # interpreted if we just set $EDITOR directly, so do a little dance with
221 # environment variables to work around this.
223 # In particular, quoting isn't enough, as the path may contain the same quote
228 EDITOR='"$FAKE_EDITOR"'
232 test_decode_color () {
235 if (n == 0) return "RESET";
236 if (n == 1) return "BOLD";
237 if (n == 30) return "BLACK";
238 if (n == 31) return "RED";
239 if (n == 32) return "GREEN";
240 if (n == 33) return "YELLOW";
241 if (n == 34) return "BLUE";
242 if (n == 35) return "MAGENTA";
243 if (n == 36) return "CYAN";
244 if (n == 37) return "WHITE";
245 if (n == 40) return "BLACK";
246 if (n == 41) return "BRED";
247 if (n == 42) return "BGREEN";
248 if (n == 43) return "BYELLOW";
249 if (n == 44) return "BBLUE";
250 if (n == 45) return "BMAGENTA";
251 if (n == 46) return "BCYAN";
252 if (n == 47) return "BWHITE";
255 while (match($0, /\033\[[0-9;]*m/) != 0) {
256 printf "%s<", substr($0, 1, RSTART-1);
257 codes = substr($0, RSTART+2, RLENGTH-3);
258 if (length(codes) == 0)
261 n = split(codes, ary, ";");
263 for (i = 1; i <= n; i++) {
264 printf "%s%s", sep, name(ary[i]);
269 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
293 sed -e 's/$/Q/' | tr Q '\015'
297 tr '\015' Q | sed -e 's/Q$//'
300 # In some bourne shell implementations, the "unset" builtin returns
301 # nonzero status when a variable to be unset was not set in the first
304 # Use sane_unset when that should not be considered an error.
312 if test -z "${test_tick+set}"
316 test_tick=$(($test_tick + 60))
318 GIT_COMMITTER_DATE="$test_tick -0700"
319 GIT_AUTHOR_DATE="$test_tick -0700"
320 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
323 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
325 # This will commit a file with the given contents and the given commit
326 # message. It will also add a tag with <message> as name.
328 # Both <file> and <contents> default to <message>.
332 echo "${3-$1}" > "$file" &&
335 git commit -m "$1" &&
339 # Call test_merge with the arguments "<message> <commit>", where <commit>
340 # can be a tag pointing to the commit-to-merge.
344 git merge -m "$1" "$2" &&
348 # This function helps systems where core.filemode=false is set.
349 # Use it instead of plain 'chmod +x' to set or unset the executable bit
350 # of a file in the working directory and add it to the index.
354 git update-index --add "--chmod=$@"
357 # Use test_set_prereq to tell that a particular prerequisite is available.
358 # The prerequisite can later be checked for in two ways:
360 # - Explicitly using test_have_prereq.
362 # - Implicitly by specifying the prerequisite tag in the calls to
363 # test_expect_{success,failure,code}.
365 # The single parameter is the prerequisite tag (a simple word, in all
366 # capital letters by convention).
369 satisfied="$satisfied$1 "
373 test_have_prereq () {
374 # prerequisites can be concatenated with ','
386 total_prereq=$(($total_prereq + 1))
389 ok_prereq=$(($ok_prereq + 1))
392 # Keep a list of missing prerequisites
393 if test -z "$missing_prereq"
395 missing_prereq=$prerequisite
397 missing_prereq="$prerequisite,$missing_prereq"
402 test $total_prereq = $ok_prereq
405 test_declared_prereq () {
406 case ",$test_prereq," in
414 # You are not expected to call test_ok_ and test_failure_ directly, use
415 # the text_expect_* functions instead.
418 test_success=$(($test_success + 1))
419 say_color "" "ok $test_count - $@"
423 test_failure=$(($test_failure + 1))
424 say_color error "not ok - $test_count $1"
426 echo "$@" | sed -e 's/^/# /'
427 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
430 test_known_broken_ok_ () {
431 test_fixed=$(($test_fixed+1))
432 say_color "" "ok $test_count - $@ # TODO known breakage"
435 test_known_broken_failure_ () {
436 test_broken=$(($test_broken+1))
437 say_color skip "not ok $test_count - $@ # TODO known breakage"
441 test "$debug" = "" || eval "$1"
448 eval >&3 2>&4 "$test_cleanup"
449 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
456 test_count=$(($test_count+1))
458 for skp in $GIT_SKIP_TESTS
460 case $this_test.$test_count in
466 if test -z "$to_skip" && test -n "$test_prereq" &&
467 ! test_have_prereq "$test_prereq"
474 if test "$missing_prereq" != "$test_prereq"
476 of_prereq=" of $test_prereq"
479 say_color skip >&3 "skipping test: $@"
480 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
489 test_expect_failure () {
490 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
492 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
496 say >&3 "checking known breakage: $2"
498 if [ "$?" = 0 -a "$eval_ret" = 0 ]
500 test_known_broken_ok_ "$1"
502 test_known_broken_failure_ "$1"
508 test_expect_success () {
509 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
511 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
515 say >&3 "expecting success: $2"
517 if [ "$?" = 0 -a "$eval_ret" = 0 ]
527 # test_external runs external test scripts that provide continuous
528 # test output about their progress, and succeeds/fails on
529 # zero/non-zero exit code. It outputs the test output on stdout even
530 # in non-verbose mode, and announces the external script with "# run
531 # <n>: ..." before running it. When providing relative paths, keep in
532 # mind that all scripts run in "trash directory".
533 # Usage: test_external description command arguments...
534 # Example: test_external 'Perl API' perl ../path/to/test.pl
536 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
538 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
542 if ! test_skip "$descr" "$@"
544 # Announce the script to reduce confusion about the
545 # test output that follows.
546 say_color "" "# run $test_count: $descr ($*)"
547 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
548 # to be able to use them in script
549 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
550 # Run command; redirect its stderr to &4 as in
551 # test_run_, but keep its stdout on our stdout even in
556 if test $test_external_has_tap -eq 0; then
559 say_color "" "# test_external test $descr was ok"
560 test_success=$(($test_success + 1))
563 if test $test_external_has_tap -eq 0; then
564 test_failure_ "$descr" "$@"
566 say_color error "# test_external test $descr failed: $@"
567 test_failure=$(($test_failure + 1))
573 # Like test_external, but in addition tests that the command generated
574 # no output on stderr.
575 test_external_without_stderr () {
576 # The temporary file has no (and must have no) security
578 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
579 stderr="$tmp/git-external-stderr.$$.tmp"
580 test_external "$@" 4> "$stderr"
581 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
582 descr="no stderr: $1"
584 say >&3 "# expecting no stderr from previous command"
585 if [ ! -s "$stderr" ]; then
588 if test $test_external_has_tap -eq 0; then
591 say_color "" "# test_external_without_stderr test $descr was ok"
592 test_success=$(($test_success + 1))
595 if [ "$verbose" = t ]; then
596 output=`echo; echo "# Stderr is:"; cat "$stderr"`
600 # rm first in case test_failure exits.
602 if test $test_external_has_tap -eq 0; then
603 test_failure_ "$descr" "$@" "$output"
605 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
606 test_failure=$(($test_failure + 1))
611 # debugging-friendly alternatives to "test [-f|-d|-e]"
612 # The commands test the existence or non-existence of $1. $2 can be
613 # given to provide a more precise diagnosis.
614 test_path_is_file () {
617 echo "File $1 doesn't exist. $*"
622 test_path_is_dir () {
625 echo "Directory $1 doesn't exist. $*"
630 test_path_is_missing () {
635 if [ $# -ge 1 ]; then
642 # test_line_count checks that a file has the number of lines it
643 # ought to. For example:
645 # test_expect_success 'produce exactly one line of output' '
646 # do something >output &&
647 # test_line_count = 1 output
650 # is like "test $(wc -l <output) = 1" except that it passes the
651 # output through when the number of lines is wrong.
656 error "bug in the test script: not 3 parameters to test_line_count"
657 elif ! test $(wc -l <"$3") "$1" "$2"
659 echo "test_line_count: line count for $3 !$1 $2"
665 # This is not among top-level (test_expect_success | test_expect_failure)
666 # but is a prefix that can be used in the test script, like:
668 # test_expect_success 'complain and die' '
670 # do something else &&
671 # test_must_fail git checkout ../outerspace
674 # Writing this as "! git checkout ../outerspace" is wrong, because
675 # the failure could be due to a segv. We want a controlled failure.
680 if test $exit_code = 0; then
681 echo >&2 "test_must_fail: command succeeded: $*"
683 elif test $exit_code -gt 129 -a $exit_code -le 192; then
684 echo >&2 "test_must_fail: died by signal: $*"
686 elif test $exit_code = 127; then
687 echo >&2 "test_must_fail: command not found: $*"
693 # Similar to test_must_fail, but tolerates success, too. This is
694 # meant to be used in contexts like:
696 # test_expect_success 'some command works without configuration' '
697 # test_might_fail git config --unset all.configuration &&
701 # Writing "git config --unset all.configuration || :" would be wrong,
702 # because we want to notice if it fails due to segv.
707 if test $exit_code -gt 129 -a $exit_code -le 192; then
708 echo >&2 "test_might_fail: died by signal: $*"
710 elif test $exit_code = 127; then
711 echo >&2 "test_might_fail: command not found: $*"
717 # Similar to test_must_fail and test_might_fail, but check that a
718 # given command exited with a given exit code. Meant to be used as:
720 # test_expect_success 'Merge with d/f conflicts' '
721 # test_expect_code 1 git merge "merge msg" B master
724 test_expect_code () {
729 if test $exit_code = $want_code
731 echo >&2 "test_expect_code: command exited with $exit_code: $*"
734 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
739 # test_cmp is a helper function to compare actual and expected output.
740 # You can use it like:
742 # test_expect_success 'foo works' '
743 # echo expected >expected &&
745 # test_cmp expected actual
748 # This could be written as either "cmp" or "diff -u", but:
749 # - cmp's output is not nearly as easy to read as diff -u
750 # - not all diff versions understand "-u"
756 # This function can be used to schedule some commands to be run
757 # unconditionally at the end of the test to restore sanity:
759 # test_expect_success 'test core.capslock' '
760 # git config core.capslock true &&
761 # test_when_finished "git config --unset core.capslock" &&
765 # That would be roughly equivalent to
767 # test_expect_success 'test core.capslock' '
768 # git config core.capslock true &&
770 # git config --unset core.capslock
773 # except that the greeting and config --unset must both succeed for
776 test_when_finished () {
778 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
781 # Most tests can use the created repository, but some may need to create more.
782 # Usage: test_create_repo <directory>
783 test_create_repo () {
785 error "bug in the test script: not 1 parameter to test-create-repo"
789 cd "$repo" || error "Cannot setup test environment"
790 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
791 error "cannot run git init -- have you built things yet?"
792 mv .git/hooks .git/hooks-disabled
799 if test -z "$HARNESS_ACTIVE"; then
800 test_results_dir="$TEST_DIRECTORY/test-results"
801 mkdir -p "$test_results_dir"
802 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
804 echo "total $test_count" >> $test_results_path
805 echo "success $test_success" >> $test_results_path
806 echo "fixed $test_fixed" >> $test_results_path
807 echo "broken $test_broken" >> $test_results_path
808 echo "failed $test_failure" >> $test_results_path
809 echo "" >> $test_results_path
812 if test "$test_fixed" != 0
814 say_color pass "# fixed $test_fixed known breakage(s)"
816 if test "$test_broken" != 0
818 say_color error "# still have $test_broken known breakage(s)"
819 msg="remaining $(($test_count-$test_broken)) test(s)"
821 msg="$test_count test(s)"
823 case "$test_failure" in
825 # Maybe print SKIP message
826 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
828 if test $test_external_has_tap -eq 0; then
829 say_color pass "# passed all $msg"
830 say "1..$test_count$skip_all"
833 test -d "$remove_trash" &&
834 cd "$(dirname "$remove_trash")" &&
835 rm -rf "$(basename "$remove_trash")"
840 if test $test_external_has_tap -eq 0; then
841 say_color error "# failed $test_failure among $msg"
850 # Test the binaries we have just built. The tests are kept in
851 # t/ subdirectory and are run in 'trash directory' subdirectory.
852 if test -z "$TEST_DIRECTORY"
854 # We allow tests to override this, in case they want to run tests
855 # outside of t/, e.g. for running tests on the test library
857 TEST_DIRECTORY=$(pwd)
859 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
861 if test -n "$valgrind"
865 test "$1" = "$(readlink "$2")" || {
873 while test -d "$2".lock
875 say "Waiting for lock on $2."
882 make_valgrind_symlink () {
883 # handle only executables
884 test -x "$1" || return
886 base=$(basename "$1")
887 symlink_target=$GIT_BUILD_DIR/$base
888 # do not override scripts
889 if test -x "$symlink_target" &&
890 test ! -d "$symlink_target" &&
891 test "#!" != "$(head -c 2 < "$symlink_target")"
893 symlink_target=../valgrind.sh
897 symlink_target=../unprocessed-script
899 # create the link, or replace it if it is out of date
900 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
903 # override all git executables in TEST_DIRECTORY/..
904 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
905 mkdir -p "$GIT_VALGRIND"/bin
906 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
908 make_valgrind_symlink $file
914 ls "$path"/git-* 2> /dev/null |
917 make_valgrind_symlink "$file"
921 PATH=$GIT_VALGRIND/bin:$PATH
922 GIT_EXEC_PATH=$GIT_VALGRIND/bin
924 elif test -n "$GIT_TEST_INSTALLED" ; then
925 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
926 error "Cannot run git from $GIT_TEST_INSTALLED."
927 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
928 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
929 else # normal case, use ../bin-wrappers only unless $with_dashes:
930 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
931 if ! test -x "$git_bin_dir/git" ; then
932 if test -z "$with_dashes" ; then
933 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
937 PATH="$git_bin_dir:$PATH"
938 GIT_EXEC_PATH=$GIT_BUILD_DIR
939 if test -n "$with_dashes" ; then
940 PATH="$GIT_BUILD_DIR:$PATH"
943 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
945 GIT_CONFIG_NOSYSTEM=1
947 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
949 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
951 if test -z "$GIT_TEST_CMP"
953 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
955 GIT_TEST_CMP="$DIFF -c"
957 GIT_TEST_CMP="$DIFF -u"
961 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
963 test -d "$GIT_BUILD_DIR"/templates/blt || {
964 error "You haven't built things yet, have you?"
967 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
969 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
971 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
972 error "You haven't built git_remote_helpers yet, have you?"
976 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
977 echo >&2 'You need to build test-chmtime:'
978 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
983 test="trash directory.$(basename "$0" .sh)"
984 test -n "$root" && test="$root/$test"
986 /*) TRASH_DIRECTORY="$test" ;;
987 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
989 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
992 echo >&5 "FATAL: Cannot prepare test area"
996 HOME="$TRASH_DIRECTORY"
999 test_create_repo "$test"
1000 # Use -P to resolve symlinks in our working directory so that the cwd
1001 # in subprocesses like git equals our $PWD (for pathname comparisons).
1002 cd -P "$test" || exit 1
1005 this_test=${this_test%%-*}
1006 for skp in $GIT_SKIP_TESTS
1008 case "$this_test" in
1010 say_color skip >&3 "skipping test $this_test altogether"
1011 skip_all="skip all tests in $this_test"
1016 # Provide an implementation of the 'yes' utility
1031 # Fix some commands on Windows
1034 # Windows has its own (incompatible) sort and find
1044 # git sees Windows-style pwd
1048 # no POSIX permissions
1049 # backslashes in pathspec are converted to '/'
1050 # exec does not inherit the PID
1051 test_set_prereq MINGW
1052 test_set_prereq SED_STRIPS_CR
1055 test_set_prereq POSIXPERM
1056 test_set_prereq EXECKEEPSPID
1057 test_set_prereq NOT_MINGW
1058 test_set_prereq SED_STRIPS_CR
1061 test_set_prereq POSIXPERM
1062 test_set_prereq BSLASHPSPEC
1063 test_set_prereq EXECKEEPSPID
1064 test_set_prereq NOT_MINGW
1068 test -z "$NO_PERL" && test_set_prereq PERL
1069 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1071 # Can we rely on git's output in the C locale?
1072 if test -n "$GETTEXT_POISON"
1074 GIT_GETTEXT_POISON=YesPlease
1075 export GIT_GETTEXT_POISON
1077 test_set_prereq C_LOCALE_OUTPUT
1080 # test whether the filesystem supports symbolic links
1081 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1084 # When the tests are run as root, permission tests will report that
1085 # things are writable when they shouldn't be.
1086 test -w / || test_set_prereq SANITY